<?php
require __DIR__ . '/vendor/autoload.php';

require __DIR__ . '/functions.php';


$appointment_ids = $customer_ids = $appointment_type_ids  = $sheet_data = [];
$appointment_id = $appointment_type = $appointment_date = $customer_phone = $customer_fname = "";

//Google sheet data
$sheetID = "1gEeUFv88O_vecU4lmgs2ujkiQQZjtB3Wb-JXZqQ7tsE";
$sheetName = "Mint Pest";

// API credentials
$base_url               = 'https://mintpest.fieldroutes.com/api';
$authenticationKey      = '78m4123bukkepv6fkbgcs1d9m4pro8l8qtbk2v4v06puk9d1j65951gmklaevtgj';
$authenticationToken    = 'crogal2h5ee24gbos6edu5o91592ons909el99rj19hipp5i2pbsr86hdev4l2ei';
$auth_url               = 'authenticationKey=' . $authenticationKey . '&authenticationToken=' . $authenticationToken;

//APIs Endpoints
$search_all_appointment     = '/appointment/search/';   // to retrieve all the appointment ids
$search_single_appointment  = '/appointment/';          // to retrieve single appointment details
$search_customer            = '/customer/';             // to retrieve customer details
$search_appointment_type    = '/serviceType/';          // to retrieve appointment type details

$dateAddedEnd = $dateAddedStart = get_previous_date_edt();
// $dateAddedEnd = $dateAddedStart = '2024-07-13'; // for testing 

$get_appointments_url = $base_url . $search_all_appointment . '?dateAddedStart=' . $dateAddedStart . '&dateAddedEnd=' . $dateAddedEnd . '&' . $auth_url;

// https://mintpest.fieldroutes.com/api/appointment/search?dateAddedStart=2024-06-17&dateAddedEnd=2024-06-17&authenticationKey=78m4123bukkepv6fkbgcs1d9m4pro8l8qtbk2v4v06puk9d1j65951gmklaevtgj&authenticationToken=crogal2h5ee24gbos6edu5o91592ons909el99rj19hipp5i2pbsr86hdev4l2ei

$get_appointments_response = @file_get_contents($get_appointments_url);
if ($get_appointments_response === FALSE) {
    die('Error occurred while fetching appointments');
}
$get_appointments_data = json_decode($get_appointments_response, true);

if (!empty($get_appointments_data['success'])) {
    
    $appointment_ids = $get_appointments_data['appointmentIDs'];
    
    $last_appointment_ids = get_last_appointment_id();
    $last_appointment_id = $last_appointment_ids['application_Id'];
    
    $last_key = array_search($last_appointment_id, $appointment_ids);
    $last_key = empty($last_key)? 0 : $last_key + 1;
    
    $appointment_ids = array_slice($appointment_ids, $last_key, 17);
    
    $last_id = end($appointment_ids);
    
    insert_appointment_id($last_id);
    
    // $appointment_ids = array_reverse($appointment_ids);

    if (!empty($appointment_ids)) {

        foreach ($appointment_ids as $key => $appointment_id) {
            // if($key >= 5) break;
           
            $get_single_appointment_url = $base_url . $search_single_appointment . '/' . $appointment_id . '?' . $auth_url;
            // https://mintpest.fieldroutes.com/api/appointment/110025?&authenticationKey=78m4123bukkepv6fkbgcs1d9m4pro8l8qtbk2v4v06puk9d1j65951gmklaevtgj&authenticationToken=crogal2h5ee24gbos6edu5o91592ons909el99rj19hipp5i2pbsr86hdev4l2ei

            $get_single_appointment_response = @file_get_contents($get_single_appointment_url);
            if ($get_single_appointment_response === FALSE) {
                die('Error occurred while fetching single appointment');
            }

            $get_single_appointment_data = json_decode($get_single_appointment_response, true);

            if (!empty($get_single_appointment_data['success'])) {
                $appointment_date = $get_single_appointment_data['appointment']['date']; // anointment date
                $customer_id = $get_single_appointment_data['appointment']['customerID'];

                $get_customer_url = $base_url . $search_customer . '/' . $customer_id . '?' . $auth_url;
                // https://mintpest.fieldroutes.com/api/customer/20585?&authenticationKey=78m4123bukkepv6fkbgcs1d9m4pro8l8qtbk2v4v06puk9d1j65951gmklaevtgj&authenticationToken=crogal2h5ee24gbos6edu5o91592ons909el99rj19hipp5i2pbsr86hdev4l2ei

                $get_customer_response = @file_get_contents($get_customer_url);
                if ($get_customer_response === FALSE) {
                    die('Error occurred while fetching customer details');
                }
                $get_customer_data = json_decode($get_customer_response, true);

                $customer_fname  = $get_customer_data['customer']['fname']; // custom first name
                $customer_phone  = $get_customer_data['customer']['billingPhone']; // customer phone number

                $appointment_type_id = $get_single_appointment_data['appointment']['type'];
                $get_appointment_type_url = $base_url . $search_appointment_type . '/' . $appointment_type_id . '?' . $auth_url;
                // https://mintpest.fieldroutes.com/api/customer/20585?&authenticationKey=78m4123bukkepv6fkbgcs1d9m4pro8l8qtbk2v4v06puk9d1j65951gmklaevtgj&authenticationToken=crogal2h5ee24gbos6edu5o91592ons909el99rj19hipp5i2pbsr86hdev4l2ei

                $get_appointment_type_response = @file_get_contents($get_appointment_type_url);
                if ($get_appointment_type_response === FALSE) {
                    die('Error occurred while fetching appointment type details');
                }
                $get_appointment_type_data = json_decode($get_appointment_type_response, true);

                $appointment_type = $get_appointment_type_data['serviceType']['description']; // appointment type

                $sheet_data[] = [
                    $appointment_id,
                    $customer_fname,
                    $customer_phone,
                    $appointment_date,
                    $appointment_type,
                ];
            } else {
                die($get_single_appointment_data['errorMessage']);
            }
        }
        // Insert the data into the Google Sheet
        insert_data_google_sheet($sheetID, $sheetName, $sheet_data);
    } else {
        echo "No apponiment found";
    }
} else {
    die($get_appointments_data['errorMessage']);
}


